Merge branch 'mm/config-xdg'
[git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22         # do not redirect again
23         ;;
24 *' --tee '*|*' --va'*)
25         mkdir -p test-results
26         BASE=test-results/$(basename "$0" .sh)
27         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28          echo $? > $BASE.exit) | tee $BASE.out
29         test "$(cat $BASE.exit)" = 0
30         exit
31         ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 # A call to "unset" with no arguments causes at least Solaris 10
46 # /usr/xpg4/bin/sh and /bin/ksh to bail out.  So keep the unsets
47 # deriving from the command substitution clustered with the other
48 # ones.
49 unset VISUAL EMAIL LANGUAGE COLUMNS $(perl -e '
50         my @env = keys %ENV;
51         my $ok = join("|", qw(
52                 TRACE
53                 DEBUG
54                 USE_LOOKUP
55                 TEST
56                 .*_TEST
57                 PROVE
58                 VALGRIND
59                 PERF_AGGREGATING_LATER
60         ));
61         my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
62         print join("\n", @vars);
63 ')
64 unset XDG_CONFIG_HOME
65 GIT_AUTHOR_EMAIL=author@example.com
66 GIT_AUTHOR_NAME='A U Thor'
67 GIT_COMMITTER_EMAIL=committer@example.com
68 GIT_COMMITTER_NAME='C O Mitter'
69 GIT_MERGE_VERBOSITY=5
70 GIT_MERGE_AUTOEDIT=no
71 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
72 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
73 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
74 export EDITOR
75
76 # Protect ourselves from common misconfiguration to export
77 # CDPATH into the environment
78 unset CDPATH
79
80 unset GREP_OPTIONS
81
82 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
83         1|2|true)
84                 echo "* warning: Some tests will not work if GIT_TRACE" \
85                         "is set as to trace on STDERR ! *"
86                 echo "* warning: Please set GIT_TRACE to something" \
87                         "other than 1, 2 or true ! *"
88                 ;;
89 esac
90
91 # Convenience
92 #
93 # A regexp to match 5 and 40 hexdigits
94 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
95 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
96
97 # Zero SHA-1
98 _z40=0000000000000000000000000000000000000000
99
100 # Line feed
101 LF='
102 '
103
104 export _x05 _x40 _z40 LF
105
106 # Each test should start with something like this, after copyright notices:
107 #
108 # test_description='Description of this test...
109 # This test checks if command xyzzy does the right thing...
110 # '
111 # . ./test-lib.sh
112 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
113                 TERM=$ORIGINAL_TERM &&
114                 export TERM &&
115                 [ -t 1 ] &&
116                 tput bold >/dev/null 2>&1 &&
117                 tput setaf 1 >/dev/null 2>&1 &&
118                 tput sgr0 >/dev/null 2>&1
119         ) &&
120         color=t
121
122 while test "$#" -ne 0
123 do
124         case "$1" in
125         -d|--d|--de|--deb|--debu|--debug)
126                 debug=t; shift ;;
127         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
128                 immediate=t; shift ;;
129         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
130                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
131         -h|--h|--he|--hel|--help)
132                 help=t; shift ;;
133         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
134                 verbose=t; shift ;;
135         -q|--q|--qu|--qui|--quie|--quiet)
136                 # Ignore --quiet under a TAP::Harness. Saying how many tests
137                 # passed without the ok/not ok details is always an error.
138                 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
139         --with-dashes)
140                 with_dashes=t; shift ;;
141         --no-color)
142                 color=; shift ;;
143         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
144                 valgrind=t; verbose=t; shift ;;
145         --tee)
146                 shift ;; # was handled already
147         --root=*)
148                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
149                 shift ;;
150         *)
151                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
152         esac
153 done
154
155 if test -n "$color"; then
156         say_color () {
157                 (
158                 TERM=$ORIGINAL_TERM
159                 export TERM
160                 case "$1" in
161                         error) tput bold; tput setaf 1;; # bold red
162                         skip)  tput bold; tput setaf 2;; # bold green
163                         pass)  tput setaf 2;;            # green
164                         info)  tput setaf 3;;            # brown
165                         *) test -n "$quiet" && return;;
166                 esac
167                 shift
168                 printf "%s" "$*"
169                 tput sgr0
170                 echo
171                 )
172         }
173 else
174         say_color() {
175                 test -z "$1" && test -n "$quiet" && return
176                 shift
177                 echo "$*"
178         }
179 fi
180
181 error () {
182         say_color error "error: $*"
183         GIT_EXIT_OK=t
184         exit 1
185 }
186
187 say () {
188         say_color info "$*"
189 }
190
191 test "${test_description}" != "" ||
192 error "Test script did not set test_description."
193
194 if test "$help" = "t"
195 then
196         echo "$test_description"
197         exit 0
198 fi
199
200 exec 5>&1
201 exec 6<&0
202 if test "$verbose" = "t"
203 then
204         exec 4>&2 3>&1
205 else
206         exec 4>/dev/null 3>/dev/null
207 fi
208
209 test_failure=0
210 test_count=0
211 test_fixed=0
212 test_broken=0
213 test_success=0
214
215 test_external_has_tap=0
216
217 die () {
218         code=$?
219         if test -n "$GIT_EXIT_OK"
220         then
221                 exit $code
222         else
223                 echo >&5 "FATAL: Unexpected exit with code $code"
224                 exit 1
225         fi
226 }
227
228 GIT_EXIT_OK=
229 trap 'die' EXIT
230
231 # The user-facing functions are loaded from a separate file so that
232 # test_perf subshells can have them too
233 . "${TEST_DIRECTORY:-.}"/test-lib-functions.sh
234
235 # You are not expected to call test_ok_ and test_failure_ directly, use
236 # the text_expect_* functions instead.
237
238 test_ok_ () {
239         test_success=$(($test_success + 1))
240         say_color "" "ok $test_count - $@"
241 }
242
243 test_failure_ () {
244         test_failure=$(($test_failure + 1))
245         say_color error "not ok - $test_count $1"
246         shift
247         echo "$@" | sed -e 's/^/#       /'
248         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
249 }
250
251 test_known_broken_ok_ () {
252         test_fixed=$(($test_fixed+1))
253         say_color "" "ok $test_count - $@ # TODO known breakage"
254 }
255
256 test_known_broken_failure_ () {
257         test_broken=$(($test_broken+1))
258         say_color skip "not ok $test_count - $@ # TODO known breakage"
259 }
260
261 test_debug () {
262         test "$debug" = "" || eval "$1"
263 }
264
265 test_eval_ () {
266         # This is a separate function because some tests use
267         # "return" to end a test_expect_success block early.
268         eval </dev/null >&3 2>&4 "$*"
269 }
270
271 test_run_ () {
272         test_cleanup=:
273         expecting_failure=$2
274         test_eval_ "$1"
275         eval_ret=$?
276
277         if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
278         then
279                 test_eval_ "$test_cleanup"
280         fi
281         if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
282                 echo ""
283         fi
284         return "$eval_ret"
285 }
286
287 test_skip () {
288         test_count=$(($test_count+1))
289         to_skip=
290         for skp in $GIT_SKIP_TESTS
291         do
292                 case $this_test.$test_count in
293                 $skp)
294                         to_skip=t
295                         break
296                 esac
297         done
298         if test -z "$to_skip" && test -n "$test_prereq" &&
299            ! test_have_prereq "$test_prereq"
300         then
301                 to_skip=t
302         fi
303         case "$to_skip" in
304         t)
305                 of_prereq=
306                 if test "$missing_prereq" != "$test_prereq"
307                 then
308                         of_prereq=" of $test_prereq"
309                 fi
310
311                 say_color skip >&3 "skipping test: $@"
312                 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
313                 : true
314                 ;;
315         *)
316                 false
317                 ;;
318         esac
319 }
320
321 # stub; perf-lib overrides it
322 test_at_end_hook_ () {
323         :
324 }
325
326 test_done () {
327         GIT_EXIT_OK=t
328
329         if test -z "$HARNESS_ACTIVE"; then
330                 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
331                 mkdir -p "$test_results_dir"
332                 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
333
334                 cat >>"$test_results_path" <<-EOF
335                 total $test_count
336                 success $test_success
337                 fixed $test_fixed
338                 broken $test_broken
339                 failed $test_failure
340
341                 EOF
342         fi
343
344         if test "$test_fixed" != 0
345         then
346                 say_color pass "# fixed $test_fixed known breakage(s)"
347         fi
348         if test "$test_broken" != 0
349         then
350                 say_color error "# still have $test_broken known breakage(s)"
351                 msg="remaining $(($test_count-$test_broken)) test(s)"
352         else
353                 msg="$test_count test(s)"
354         fi
355         case "$test_failure" in
356         0)
357                 # Maybe print SKIP message
358                 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
359
360                 if test $test_external_has_tap -eq 0; then
361                         say_color pass "# passed all $msg"
362                         say "1..$test_count$skip_all"
363                 fi
364
365                 test -d "$remove_trash" &&
366                 cd "$(dirname "$remove_trash")" &&
367                 rm -rf "$(basename "$remove_trash")"
368
369                 test_at_end_hook_
370
371                 exit 0 ;;
372
373         *)
374                 if test $test_external_has_tap -eq 0; then
375                         say_color error "# failed $test_failure among $msg"
376                         say "1..$test_count"
377                 fi
378
379                 exit 1 ;;
380
381         esac
382 }
383
384 # Test the binaries we have just built.  The tests are kept in
385 # t/ subdirectory and are run in 'trash directory' subdirectory.
386 if test -z "$TEST_DIRECTORY"
387 then
388         # We allow tests to override this, in case they want to run tests
389         # outside of t/, e.g. for running tests on the test library
390         # itself.
391         TEST_DIRECTORY=$(pwd)
392 fi
393 if test -z "$TEST_OUTPUT_DIRECTORY"
394 then
395         # Similarly, override this to store the test-results subdir
396         # elsewhere
397         TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
398 fi
399 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
400
401 if test -n "$valgrind"
402 then
403         make_symlink () {
404                 test -h "$2" &&
405                 test "$1" = "$(readlink "$2")" || {
406                         # be super paranoid
407                         if mkdir "$2".lock
408                         then
409                                 rm -f "$2" &&
410                                 ln -s "$1" "$2" &&
411                                 rm -r "$2".lock
412                         else
413                                 while test -d "$2".lock
414                                 do
415                                         say "Waiting for lock on $2."
416                                         sleep 1
417                                 done
418                         fi
419                 }
420         }
421
422         make_valgrind_symlink () {
423                 # handle only executables, unless they are shell libraries that
424                 # need to be in the exec-path.  We will just use "#!" as a
425                 # guess for a shell-script, since we have no idea what the user
426                 # may have configured as the shell path.
427                 test -x "$1" ||
428                 test "#!" = "$(head -c 2 <"$1")" ||
429                 return;
430
431                 base=$(basename "$1")
432                 symlink_target=$GIT_BUILD_DIR/$base
433                 # do not override scripts
434                 if test -x "$symlink_target" &&
435                     test ! -d "$symlink_target" &&
436                     test "#!" != "$(head -c 2 < "$symlink_target")"
437                 then
438                         symlink_target=../valgrind.sh
439                 fi
440                 case "$base" in
441                 *.sh|*.perl)
442                         symlink_target=../unprocessed-script
443                 esac
444                 # create the link, or replace it if it is out of date
445                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
446         }
447
448         # override all git executables in TEST_DIRECTORY/..
449         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
450         mkdir -p "$GIT_VALGRIND"/bin
451         for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
452         do
453                 make_valgrind_symlink $file
454         done
455         # special-case the mergetools loadables
456         make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
457         OLDIFS=$IFS
458         IFS=:
459         for path in $PATH
460         do
461                 ls "$path"/git-* 2> /dev/null |
462                 while read file
463                 do
464                         make_valgrind_symlink "$file"
465                 done
466         done
467         IFS=$OLDIFS
468         PATH=$GIT_VALGRIND/bin:$PATH
469         GIT_EXEC_PATH=$GIT_VALGRIND/bin
470         export GIT_VALGRIND
471 elif test -n "$GIT_TEST_INSTALLED" ; then
472         GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
473         error "Cannot run git from $GIT_TEST_INSTALLED."
474         PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
475         GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
476 else # normal case, use ../bin-wrappers only unless $with_dashes:
477         git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
478         if ! test -x "$git_bin_dir/git" ; then
479                 if test -z "$with_dashes" ; then
480                         say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
481                 fi
482                 with_dashes=t
483         fi
484         PATH="$git_bin_dir:$PATH"
485         GIT_EXEC_PATH=$GIT_BUILD_DIR
486         if test -n "$with_dashes" ; then
487                 PATH="$GIT_BUILD_DIR:$PATH"
488         fi
489 fi
490 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
491 unset GIT_CONFIG
492 GIT_CONFIG_NOSYSTEM=1
493 GIT_ATTR_NOSYSTEM=1
494 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
495
496 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
497
498 export PERL_PATH
499
500 if test -z "$GIT_TEST_CMP"
501 then
502         if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
503         then
504                 GIT_TEST_CMP="$DIFF -c"
505         else
506                 GIT_TEST_CMP="$DIFF -u"
507         fi
508 fi
509
510 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
511 export GITPERLLIB
512 test -d "$GIT_BUILD_DIR"/templates/blt || {
513         error "You haven't built things yet, have you?"
514 }
515
516 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
517 then
518         GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
519         export GITPYTHONLIB
520         test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
521                 error "You haven't built git_remote_helpers yet, have you?"
522         }
523 fi
524
525 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
526         echo >&2 'You need to build test-chmtime:'
527         echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
528         exit 1
529 fi
530
531 # Test repository
532 test="trash directory.$(basename "$0" .sh)"
533 test -n "$root" && test="$root/$test"
534 case "$test" in
535 /*) TRASH_DIRECTORY="$test" ;;
536  *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
537 esac
538 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
539 rm -fr "$test" || {
540         GIT_EXIT_OK=t
541         echo >&5 "FATAL: Cannot prepare test area"
542         exit 1
543 }
544
545 HOME="$TRASH_DIRECTORY"
546 export HOME
547
548 if test -z "$TEST_NO_CREATE_REPO"; then
549         test_create_repo "$test"
550 else
551         mkdir -p "$test"
552 fi
553 # Use -P to resolve symlinks in our working directory so that the cwd
554 # in subprocesses like git equals our $PWD (for pathname comparisons).
555 cd -P "$test" || exit 1
556
557 this_test=${0##*/}
558 this_test=${this_test%%-*}
559 for skp in $GIT_SKIP_TESTS
560 do
561         case "$this_test" in
562         $skp)
563                 say_color skip >&3 "skipping test $this_test altogether"
564                 skip_all="skip all tests in $this_test"
565                 test_done
566         esac
567 done
568
569 # Provide an implementation of the 'yes' utility
570 yes () {
571         if test $# = 0
572         then
573                 y=y
574         else
575                 y="$*"
576         fi
577
578         while echo "$y"
579         do
580                 :
581         done
582 }
583
584 # Fix some commands on Windows
585 case $(uname -s) in
586 *MINGW*)
587         # Windows has its own (incompatible) sort and find
588         sort () {
589                 /usr/bin/sort "$@"
590         }
591         find () {
592                 /usr/bin/find "$@"
593         }
594         sum () {
595                 md5sum "$@"
596         }
597         # git sees Windows-style pwd
598         pwd () {
599                 builtin pwd -W
600         }
601         # no POSIX permissions
602         # backslashes in pathspec are converted to '/'
603         # exec does not inherit the PID
604         test_set_prereq MINGW
605         test_set_prereq SED_STRIPS_CR
606         ;;
607 *CYGWIN*)
608         test_set_prereq POSIXPERM
609         test_set_prereq EXECKEEPSPID
610         test_set_prereq NOT_MINGW
611         test_set_prereq SED_STRIPS_CR
612         ;;
613 *)
614         test_set_prereq POSIXPERM
615         test_set_prereq BSLASHPSPEC
616         test_set_prereq EXECKEEPSPID
617         test_set_prereq NOT_MINGW
618         ;;
619 esac
620
621 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
622 test -z "$NO_PERL" && test_set_prereq PERL
623 test -z "$NO_PYTHON" && test_set_prereq PYTHON
624 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
625 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
626
627 # Can we rely on git's output in the C locale?
628 if test -n "$GETTEXT_POISON"
629 then
630         GIT_GETTEXT_POISON=YesPlease
631         export GIT_GETTEXT_POISON
632         test_set_prereq GETTEXT_POISON
633 else
634         test_set_prereq C_LOCALE_OUTPUT
635 fi
636
637 # Use this instead of test_cmp to compare files that contain expected and
638 # actual output from git commands that can be translated.  When running
639 # under GETTEXT_POISON this pretends that the command produced expected
640 # results.
641 test_i18ncmp () {
642         test -n "$GETTEXT_POISON" || test_cmp "$@"
643 }
644
645 # Use this instead of "grep expected-string actual" to see if the
646 # output from a git command that can be translated either contains an
647 # expected string, or does not contain an unwanted one.  When running
648 # under GETTEXT_POISON this pretends that the command produced expected
649 # results.
650 test_i18ngrep () {
651         if test -n "$GETTEXT_POISON"
652         then
653             : # pretend success
654         elif test "x!" = "x$1"
655         then
656                 shift
657                 ! grep "$@"
658         else
659                 grep "$@"
660         fi
661 }
662
663 # test whether the filesystem supports symbolic links
664 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
665 rm -f y
666
667 # When the tests are run as root, permission tests will report that
668 # things are writable when they shouldn't be.
669 test -w / || test_set_prereq SANITY